function get_background, cubename, cube, plotflag

; extracts a background row from a data cube (as 
; resulting from 'get_cube') and subtracts it from 
; all rows. 
; Only applies for cubes in case-block.

case 1 of 
        (cubename eq "helium2"): backgroundline = 14
        (cubename eq "serts"):   backgroundline = 0
	(cubename eq "neon8"):	 backgroundline = 5 ;[0,10]
	(cubename eq "neon8y2"): backgroundline = [0,15]
	(cubename eq "neon8l2"): backgroundline = [0,7]
        (cubename eq "neon8x2"): backgroundline = [0,15]
        (cubename eq "neon8l2x2"): backgroundline = [0,7]
	(strmid(cubename,0,6) eq "random"): backgroundline = 0
	(cubename eq "artif1"): backgroundline = [0,10]
	(cubename eq "art_fe_ix"): backgroundline = [80,99]
	else: backgroundline = -1
endcase

cubesize=size(cube)
Nl = cubesize[1]
Nx = cubesize[2]
totslice = cubesize[3]

out = fltarr(Nl,Nx,totslice)

if plotflag eq 1 then begin
	wset, 3
endif

if total(backgroundline) ne -1 then begin
	for slice = 0, totslice-1 do begin
		;tmp: 2dim image to extract background from:
		tmp = reform(cube[*,*,slice])
		dim=size(backgroundline)
		if dim[0] eq 0 then begin
			;1d line to expand to 2d background 
			backgr = reform(tmp[backgroundline,*])
		endif else begin
			tmp2 = tmp[backgroundline[0]:backgroundline[1],*]
			l=backgroundline[1]-backgroundline[0]+1
			;1d line to expand to 2d background
			backgr = total(tmp2,1)/l
		endelse
		ones = replicate(1.0,Nl)
		;background: 2d background
		background = ones#backgr
		out[*,*,slice] = background
		if plotflag eq 1 then begin
			t="background for slice "+string(strtrim(slice,2))+$
				" of "+string(strtrim(totslice,2))
			plot, total(tmp,2), title=t
			oplot, total(background,2), line=1
			wait, .3
		endif
	endfor
endif 


return, out

end
