function get_cube, cubename, mode

; 'cubename' is a string identifying the data cube to 
; process. 
;
; input: 	identifyer string, mode ("cube" or "parameters")
; output: 	if mode is "cube": datacube
;		if mode is "parameters": array [nogood, disp, lambda0]
;

;default array values
array=[0.,1.,1.]

cubefile = "datacubes/"+cubename+".sav"

case 1 of 
	(mode eq "cube") : begin
		restore, cubefile
		return, cube
		end
	(mode eq "parameters") : begin
		string=""
		openr, 5, "datacubes/DATA"
		while not eof(5) do begin
			readf, 5, string
			if (string eq cubename) then begin
				readf, 5, string
				nogood  = float(stregex(string, '[^nogood](.*)', /extract))*1.
                                readf, 5, string
                                disp    = float(stregex(string, '[^disp](.*)', /extract))*1.
                                readf, 5, string
                                lambda0 = float(stregex(string, '[^lambda0](.*)', /extract))*1.
                                readf, 5, string
                                fitstart= float(stregex(string, '[^fitstart](.*)', /extract))*1.
                                readf, 5, string
                                fitend	= float(stregex(string, '[^fitend](.*)', /extract))*1.
                                readf, 5, string

				array=[nogood,disp,lambda0,fitstart,fitend]
			endif
		endwhile
		close, 5
		return, array
		end
endcase

end

