function make_4masks, dim

; creatas a data cube holding four masks: 
; z=0: theta=-45
; z=1: theta= 0
; z=2: theta=+45
; z=3: theta= 90
; dimension is specified by 'dim', so the output cube has
; dim x dim x 4 size.

mask_t=fltarr(dim,dim,4)


mask_t[0:dim-1, 0, 1] = 1.0		; theta =  0
mask_t[0, 0:dim-1, 3] = 1.0		; theta = 90
for i=0L,dim-1 do begin
	mask_t[i,i,0] = 1.0		; theta = -45
	mask_t[i,((dim-i) mod dim),2]=1.0	; theta = +45
endfor

return, mask_t

end
