pro write_results, prefix
; 
; summarizes all results as written in 'LOGFILE' from 
; all previous runs of tomo2/widthcenter/parametertrend 
; and puts them together in "z_results", together with 
; global parameters of the cube such as 
; dimensions, zero point of line center correction, slope of 
; line center correction, number of pixels, entropy, normalised 
; entropy, mean difference of neighboring pixels, .......
; (written as an experiment to find some relation of line center 
; correction with global image parameters. None found so far...)


restore, prefix+'cube.sav'

; get zero point and slope of centerfit
string=""
openr, 1, "LOGFILE"
while not eof(1) do begin
	readf, 1, string
	str2 = strsplit(string,/extract)
	if (str2[0] eq prefix) and (str2[1] eq "centerfit") then begin
		zero=str2[3]*1.
		slope=str2[4]*1.
	endif
endwhile
close, 1

; calculate the entropy (per pixel) of the image, defined as
;  e = 1/n * summ(p ln(p))
; with n = number of positive non-zero pixels, and p = int. value in pixel
dim=size(cube)
e=0L
n=0L
for i=0,dim[1]-1 do begin
for j=0,dim[2]-1 do begin
for k=0,dim[3]-1 do begin
        x=cube[i,j,k]
        if (x gt 0) then begin
                e=e+x*alog(x)
                n=n+1.
        endif
endfor
endfor
endfor
entropy=e/n


; calculate mean difference of neighboring pixel
avimd=0.
for i=0,dim[1]-1 do begin
for j=0,dim[2]-1 do begin
for k=0,dim[3]-1 do begin
	md=0
	imd=0
	for ii=i-1,i+1 do begin
        for jj=j-1,j+1 do begin
        for kk=k-1,k+1 do begin
		case 1 of 
		(ii eq i) and (jj eq j) and (kk eq k): ; do nothing
		(ii lt 0) or (jj lt 0) or (kk lt 0): ; do nothing
		(ii ge dim[1]) or (jj ge dim[2]) or (kk ge dim[3]): ; nothing
		else: begin
			md=md+abs(cube[i,j,k]-cube[ii,jj,kk])
			imd=imd+1.
			end
		endcase
	endfor
	endfor
	endfor	
	md=md/imd
	avimd=avimd+md
endfor
endfor
endfor
avimd=avimd/(dim[1]*dim[2]*dim[3])



; calculate total intensity
totintens = total(cube)

openw, 2, "z_results", /append
s1=strtrim(string(dim[1]),2)+" "
s2=strtrim(string(dim[2]),2)+" "
s3=strtrim(string(dim[3]),2)+" "
nst = " "+strtrim(string(n),2)+" "
est = " "+strtrim(string(entropy),2)+" "
print, format='(a8,3(i4," ")," ",2(f8.4," ")," ",i7," ",f14.4,2(" ",f8.3))', $
        prefix,dim[1],dim[2],dim[3],zero,slope,n,entropy,n*entropy/totintens,avimd
printf, 2, format='(a8,3(i4," ")," ",2(f8.4," ")," ",i7," ",f14.4,2(" ",f8.3))', $
	prefix,dim[1],dim[2],dim[3],zero,slope,n,entropy,n*entropy/totintens, avimd
close, 2


end

